Subject: Re: fsl booke MM vs. SMP questions

From: Benjamin Herrenschmidt <[email-masked]>
Date: Tue, 22 May 2007 20:05:42 +1000

On Tue, 2007-05-22 at 12:02 +0200, Gabriel Paubert wrote:
> 
> Well, there should always be an stwcx. to clear reservation before
> any interrupt return. Otherwise you'll be able to cause hard to
> reproduce bugs in the interrupted code.

Well, that's the point. The BookE TLB refill exception is a very fast
path that doesn't use the normal interrupt return code path. It thus
needs to be careful about not leaving dangling reservations.

On some CPUs, there are also performance issues with leaving dangling
lwarx iirc but I don't have the details off the top of my mind.

Cheers,
Ben.